/**
 * @license
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
(function(){"use strict";var t=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(t,r.key,r)}}return function(e,n,r){if(n)t(e.prototype,n);if(r)t(e,r);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var n=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([a-zA-Z0-9-_.~]+)/},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:function r(t){return new RegExp(";"+t[1]+"=([a-zA-Z0-9-_.~]+)")}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function r(t){return new RegExp(t[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function r(t){return new RegExp(t[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function r(t){return new RegExp(t[0])}}];var a=function a(t){var e=arguments[1]===undefined?[]:arguments[1];var r=n.some(function(n){var r=t.match(n.pattern);if(!r)return false;e.push({type:n.name,match:r[0],val:r.length>1?r.slice(1):null,regex:n.regex instanceof Function?n.regex(r):n.regex});if(r[0].length<t.length)e=a(t.substr(r[0].length),e);return true});if(!r){throw new Error("Could not parse path.")}return e};var i=function(){function n(t){e(this,n);if(!t)throw new Error("Please supply a path");this.path=t;this.tokens=a(t);this.hasUrlParams=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(t){return/splat$/.test(t.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(t){return/matrix$/.test(t.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(t){return t.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).map(function(t){return t.val}).reduce(function(t,e){return t.concat(e)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(t){return t.type==="query-parameter"}).map(function(t){return t.val}).reduce(function(t,e){return t.concat(e)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(t){return t.regex!==undefined}).map(function(t){return t.regex.source}).join("")}t(n,[{key:"_urlMatch",value:function r(t,e){var n=this;var r=t.match(e);if(!r)return null;else if(!this.urlParams.length)return{};return r.slice(1,this.urlParams.length+1).reduce(function(t,e,r){t[n.urlParams[r]]=e;return t},{})}},{key:"match",value:function i(t){var e=this;var n=this._urlMatch(t,new RegExp("^"+this.source+(this.hasQueryParams?"?.*$":"$")));if(!n||!this.hasQueryParams)return n;var r=t.split("?")[1].split("&").map(function(t){return t.split("=")}).reduce(function(t,e){t[e[0]]=e[1];return t},{});if(Object.keys(r).every(function(t){return Object.keys(e.queryParams).indexOf(t)!==1})&&Object.keys(r).length===this.queryParams.length){Object.keys(r).forEach(function(t){return n[t]=r[t]});return n}return null}},{key:"partialMatch",value:function s(t){return this._urlMatch(t,new RegExp("^"+this.source))}},{key:"build",value:function u(){var t=arguments[0]===undefined?{}:arguments[0];if(!this.params.every(function(e){return t[e]!==undefined}))throw new Error("Missing parameters");var e=this.tokens.filter(function(t){return t.type!=="query-parameter"}).map(function(e){if(e.type==="url-parameter-matrix")return";"+e.val[0]+"="+t[e.val[0]];return/^url-parameter/.test(e.type)?t[e.val[0]]:e.match}).join("");var n=this.queryParams.map(function(e){return e+"="+t[e]}).join("&");return e+(n?"?"+n:"")}}]);return n}();var s=function(){function n(){var t=arguments[0]===undefined?"":arguments[0];var r=arguments[1]===undefined?"":arguments[1];var a=arguments[2]===undefined?[]:arguments[2];e(this,n);this.name=t;this.path=r;this.parser=r?new i(r):null;this.children=[];this.add(a);return this}t(n,[{key:"add",value:function r(t){var e=this;if(t instanceof Array){t.forEach(function(t){return e.add(t)});return}if(!(t instanceof n)&&!(t instanceof Object)){throw new Error("Route constructor expects routes to be an Object or an instance of Route.")}if(t instanceof Object){if(!t.name||!t.path){throw new Error("Route constructor expects routes to have an name and a path defined.")}t=new n(t.name,t.path,t.children)}if(this.children.map(function(t){return t.name}).indexOf(t.name)!==-1){throw new Error('Alias "'+t.name+'" is already defined in route node')}if(this.children.map(function(t){return t.path}).indexOf(t.path)!==-1){throw new Error('Path "'+t.path+'" is already defined in route node')}var r=t.name.split(".");if(r.length===1){this.children.push(t);this.children.sort(function(t,e){return t.hasSplatParam?-1:1})}else{var a=this.getSegmentsByName(r.slice(0,-1).join("."));if(a){a[a.length-1].add(new n(r[r.length-1],t.path,t.children))}else{throw new Error("Could not add route named '"+t.name+"', parent is missing.")}}return this}},{key:"addNode",value:function a(t,e){this.add(new n(t,e));return this}},{key:"getSegmentsByName",value:function s(t){var e=function e(t,e){var n=e.filter(function(e){return e.name===t});return n.length?n[0]:undefined};var n=[];var r=t.split(".");var a=this.children;var i=r.every(function(t){var r=e(t,a);if(r){a=r.children;n.push(r);return true}return false});return i?n:null}},{key:"getSegmentsMatchingPath",value:function u(t){var e=function e(t,n,r){var a=function(a){var i=t[a];var s=i.parser.partialMatch(n);if(s){r.push(i);Object.keys(s).forEach(function(t){return r.params[t]=s[t]});var u=n.replace(i.parser.build(s),"");if(!u.length){return{v:r}}if(!i.children.length){return{v:null}}return{v:e(i.children,u,r)}}};for(var i in t){var s=a(i);if(typeof s==="object")return s.v}return null};var n=this.parser?[this]:this.children;var r=[];r.params={};return e(n,t,r)}},{key:"getPathFromSegments",value:function o(t){return t?t.map(function(t){return t.path}).join(""):null}},{key:"getPath",value:function h(t){return this.getPathFromSegments(this.getSegmentsByName(t))}},{key:"buildPathFromSegments",value:function l(t){var e=arguments[1]===undefined?{}:arguments[1];return t?t.map(function(t){return t.parser.build(e)}).join(""):null}},{key:"buildPath",value:function c(t){var e=arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(t),e)}},{key:"getMatchPathFromSegments",value:function f(t){if(!t)return null;var e=t.map(function(t){return t.name}).join(".");var n=t.params;return{name:e,params:n}}},{key:"matchPath",value:function m(t){return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(t))}}]);return n}();"use strict";var t=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(t,r.key,r)}}return function(e,n,r){if(n)t(e.prototype,n);if(r)t(e,r);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var u=function u(t){return t.split(".").reduce(function(t,e){t.push(t.length?t[t.length-1]+"."+e:e);return t},[])};var o=function o(t,e,n){return{name:t,params:e,path:n}};var h=function(){function n(t){var r=arguments[1]===undefined?{}:arguments[1];e(this,n);this.started=false;this.callbacks={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=t instanceof s?t:new s("","",t);this.activeComponents={};this.options=r;return this}t(n,[{key:"setOption",value:function r(t,e){this.options[t]=e;return this}},{key:"add",value:function a(t){this.rootNode.add(t);return this}},{key:"addNode",value:function i(t,e){this.rootNode.addNode(t,e);return this}},{key:"onPopState",value:function h(t){var e=t.state||this.matchPath(this.getWindowPath());if(!e)return;if(this.lastKnownState&&this.areStatesEqual(e,this.lastKnownState))return;var n=this._transition(e,this.lastKnownState)}},{key:"start",value:function l(){if(this.started)return this;this.started=true;var t=this.getWindowPath();var e=this.matchPath(t);if(e){this.lastKnownState=e;window.history.replaceState(this.lastKnownState,"",this.options.useHash?"#"+t:t)}else if(this.options.defaultRoute){this.navigate(this.options.defaultRoute,this.options.defaultParams,{replace:true})}window.addEventListener("popstate",this.onPopState.bind(this));return this}},{key:"stop",value:function c(){if(!this.started)return this;this.started=false;window.removeEventListener("popstate",this.onPopState.bind(this));return this}},{key:"_invokeCallbacks",value:function f(t,e,n){var r=this;if(!this.callbacks[t])return;this.callbacks[t].forEach(function(t){t.call(r,e,n)})}},{key:"_transition",value:function m(t,e){var n=this;if(!e){this.lastKnownState=t;this._invokeCallbacks("",t,e);return true}var r=undefined;var a=false;var i=u(e.name);var s=u(t.name);var o=Math.min(i.length,s.length);for(r=0;r<o;r+=1){if(i[r]!==s[r])break}a=i.slice(r).reverse().map(function(t){return n.activeComponents[t]}).filter(function(t){return t&&t.canDeactivate}).some(function(n){return!n.canDeactivate(t,e)});if(!a){this.lastKnownState=t;if(r>0)this._invokeCallbacks(i[r-1],t,e);this._invokeCallbacks("="+t.name,t,e);this._invokeCallbacks("",t,e)}return!a}},{key:"getState",value:function d(){return this.lastKnownState}},{key:"getWindowPath",value:function p(){return this.options.useHash?window.location.hash.replace(/^#/,""):window.location.pathname}},{key:"areStatesEqual",value:function v(t,e){return t.name===e.name&&Object.keys(t.params).length===Object.keys(e.params).length&&Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"registerComponent",value:function g(t,e){if(this.activeComponents[t])console.warn("A component was alread registered for route node "+t+".");this.activeComponents[t]=e}},{key:"deregisterComponent",value:function y(t){delete this.activeComponents[t]}},{key:"addNodeListener",value:function k(t,e){if(t){var n=this.rootNode.getSegmentsByName(t);if(!n)console.warn("No route found for "+t+", listener could be never called!")}if(!this.callbacks[t])this.callbacks[t]=[];this.callbacks[t].push(e)}},{key:"removeNodeListener",value:function w(t,e){if(!this.callbacks[t])return;this.callbacks[t]=this.callbacks[t].filter(function(t){return t!==e})}},{key:"addListener",value:function b(t){this.addNodeListener("",t)}},{key:"removeListener",value:function P(t){this.removeNodeListener("",t)}},{key:"addRouteListener",value:function S(t,e){this.addNodeListener("="+t,e)}},{key:"removeRouteListener",value:function x(t,e){this.removeNodeListener("="+t,e)}},{key:"buildPath",value:function E(t,e){return(this.options.useHash?"#":"")+this.rootNode.buildPath(t,e)}},{key:"matchPath",value:function N(t){var e=this.rootNode.matchPath(t);return e?o(e.name,e.params,t):null}},{key:"navigate",value:function j(t){var e=arguments[1]===undefined?{}:arguments[1];var n=arguments[2]===undefined?{}:arguments[2];if(!this.started)return;var r=this.rootNode.buildPath(t,e);if(!r)throw new Error('Could not find route "'+t+'"');this.lastStateAttempt=o(t,e,r);var a=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(a&&!n.reload)return;var i=this._transition(this.lastStateAttempt,this.lastKnownState);if(i&&!a){window.history[n.replace?"replaceState":"pushState"](this.lastStateAttempt,"",this.options.useHash?"#"+r:r)}}}]);return n}();window.RouteNode=s;window.Router5=h})();